package org.apache.bcel.generic;

import java.io.IOException;
import java.io.DataOutputStream;

public class GOTO extends GotoInstruction implements VariableLengthInstruction
{
    GOTO() {
    }
    
    public GOTO(final InstructionHandle target) {
        super((short)167, target);
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitVariableLengthInstruction(this);
        v.visitUnconditionalBranch(this);
        v.visitBranchInstruction(this);
        v.visitGotoInstruction(this);
        v.visitGOTO(this);
    }
    
    @Override
    public void dump(final DataOutputStream out) throws IOException {
        super.setIndex(this.getTargetOffset());
        final short opcode = this.getOpcode();
        if (opcode == 167) {
            super.dump(out);
        }
        else {
            super.setIndex(this.getTargetOffset());
            out.writeByte(opcode);
            out.writeInt(super.getIndex());
        }
    }
    
    @Override
    protected int updatePosition(final int offset, final int maxOffset) {
        final int i = this.getTargetOffset();
        this.setPosition(this.getPosition() + offset);
        if (Math.abs(i) >= 32767 - maxOffset) {
            super.setOpcode((short)200);
            final short oldLength = (short)super.getLength();
            super.setLength(5);
            return super.getLength() - oldLength;
        }
        return 0;
    }
}
